
#define NRANSI
#include "nrutil.h"

void mrqmin2D2(float x1[], float x2[], float y[], int ndata, float a[], int ia[], int ma, float **covar, float **alpha, float *chisq, void funcs2D(float, float, float [], float *, float [], int), float *alamda)
{
	void covsrt2D(float **covar, int ma, int ia[], int mfit);
	void gaussj(float **a, int n, float **b, int m);
	void mrqcof2D2(float x1[], float x2[], float y[], int ndata, float a[], int ia[], int ma, float **alpha, float beta[], float *chisq, void funcs2D(float, float, float [], float *, float [], int));
	int j,k,l;
	static int mfit;
	static float ochisq,*atry,*beta,*da,**oneda;
	
	if (*alamda < 0.0) {
		atry=vector(1,ma);
		beta=vector(1,ma);
		da=vector(1,ma);
		for (mfit=0,j=1;j<=ma;j++)
			if (ia[j]) mfit++;
		oneda=matrix(1,mfit,1,1);
		*alamda=1;
		mrqcof2D2(x1,x2,y,ndata,a,ia,ma,alpha,beta,chisq,funcs2D);
		ochisq=(*chisq);
		for (j=1;j<=ma;j++) atry[j]=a[j];
	}
	for (j=1;j<=mfit;j++) {
		for (k=1;k<=mfit;k++) covar[j][k]=alpha[j][k];
		covar[j][j]=alpha[j][j]*(1.0+(*alamda));
		oneda[j][1]=beta[j];
	}
	gaussj(covar,mfit,oneda,1);
	for (j=1;j<=mfit;j++) da[j]=oneda[j][1];
	if (*alamda == 0.0) {
                covsrt2D(covar,ma,ia,mfit);
		covsrt2D(alpha,ma,ia,mfit);
		free_matrix(oneda,1,mfit,1,1);
		free_vector(da,1,ma);
		free_vector(beta,1,ma);
		free_vector(atry,1,ma);
		return;
	}
	for (j=0,l=1;l<=ma;l++)
		if (ia[l]) atry[l]=a[l]+da[++j];
	mrqcof2D2(x1,x2,y,ndata,atry,ia,ma,covar,da,chisq,funcs2D);
	if (*chisq < ochisq) {
		*alamda *= 0.9;
		ochisq=(*chisq);
		for (j=1;j<=mfit;j++) {
			for (k=1;k<=mfit;k++) alpha[j][k]=covar[j][k];
			beta[j]=da[j];
		}
		for (l=1;l<=ma;l++) a[l]=atry[l];
	} else {
		*alamda *= 10.0;
		*chisq=ochisq;
	}
}
#undef NRANSI
